// Filename           : CLICTD_regslowcontrol_comparator.sv
// Author             : Núria Egidos 
// Created on         : 20/6/18
// Last modification  : 27/9/18
// Project            : Doctoral student, verification of CLICTD
// Description        : Comparator

`ifndef __CLICTD_regslowcontrol_comparator_sv__
`define __CLICTD_regslowcontrol_comparator_sv__


// This comparator assumes in-order arrival of transactions, i.e. the order of 
// arrival of a transaction from the predictor/golden model matches the order of 
// arrival of a transaction generated by the monitor probing the outputs


// This structure will enable having more than one export in the same scoreboard; 
// when the respective anlaysis ports call write(), the factory will automatically invoke 
// write_ideal() for the export associated to the port probing the expected outputs from the
// golden model, or write_actual() for the export associated to the port probing the actual
// outputs, depending on which of the ports is calling
//`uvm_analysis_imp_decl(_ideal)
//`uvm_analysis_imp_decl(_actual)




class CLICTD_regslowcontrol_comparator extends CLICTD_comparator;
	`uvm_component_utils(CLICTD_regslowcontrol_comparator) // Register the component to the factory


	// Declaration of the export used to connect to the analysis port in the agent
  // (to probe the outputs or internal signals of the DUT)
  uvm_analysis_export #(CLICTD_slowcontrol_transaction) analysis_export_actual;
  // Declaration of the export used to connect to the analysis port in the golden 
  // model (to probe the expected outputs)
  uvm_analysis_export #(CLICTD_slowcontrol_transaction) analysis_export_ideal;


  // Declaration of the fifos used to collect the streams of transactions
  // coming from the analysis ports, so as to synchronise them to 
  // be able to compare them:
  // For the transactions coming from the golden model (to probe ideal outputs)
  uvm_tlm_analysis_fifo #(CLICTD_slowcontrol_transaction) ideal_fifo;
  // For the transactions coming from the agent (to probe actual outputs)
  uvm_tlm_analysis_fifo #(CLICTD_slowcontrol_transaction) actual_fifo;
  
	// - - - - - - - - - - - - Constructor
	function new(string name, uvm_component parent);
		super.new(name, parent);
	endfunction: new


  // - - - - - - - - - - - - Build phase: build the hierarchy
	function void build_phase(uvm_phase phase);
		super.build_phase(phase);
    
    // Create the exports
		analysis_export_actual = new("analysis_export_actual", this);
		analysis_export_ideal = new("analysis_export_ideal", this);
		// Create the FIFOs
  	actual_fifo = new("actual_fifo", this);
		ideal_fifo = new("ideal_fifo", this);
    

	endfunction: build_phase


	
  // - - - - - - - - - - - - Connect phase: connect FIFOs and exports
	function void connect_phase(uvm_phase phase);
    super.connect_phase(phase);
    analysis_export_actual.connect(actual_fifo.analysis_export);
		analysis_export_ideal.connect(ideal_fifo.analysis_export);
                                     
	endfunction: connect_phase


  // - - - - - - - - - - - - Run phase: here is where the transactions are retrieved from the 
  // exports, stored temporarily in the FIFOs to synchronise and then
  // retrieved from the FIFOs to compare them
	task run();
  
    number_transactions_evaluated[STATUS_RESET] = 0;
    number_transactions_evaluated[STATUS_SECOND_READOUT_ALL_ZEROS] = 0;
				number_transactions_evaluated[STATUS_READ_ALL_SLOWCONTROL_REGISTERS] = 0;
    fork
        // Obtain transactions from the model and from the monitor and compare them 
				regslowcontrolcomparator_action();
    join_none
    
    // The fork join_none is used to avoid that this forever begin blocks the execution of other 
   // run_phase tasks in the hierarchy
	endtask: run

  // - - - - - - - - - - - - Other tasks
  //
  // Compare the incoming transactions. This function is declared virtual so that 
  // if some other comparator is extended from this one, the child comparator can 
  // override this method, and when the method is called, the child version will be executed
	virtual function void compare(CLICTD_slowcontrol_transaction slowcontrol_transaction_ideal, CLICTD_slowcontrol_transaction slowcontrol_transaction_actual);
           // This functin will only be called when chip_status == STATUS_RESET
           bit comparison_result = slowcontrol_transaction_ideal.compare(slowcontrol_transaction_actual);
           number_transactions_evaluated[chip_status_obj.chip_status] =  number_transactions_evaluated[chip_status_obj.chip_status] + 1;
           if (number_transactions_evaluated[chip_status_obj.chip_status] == 1) number_discrepancies[chip_status_obj.chip_status] = 0; // there will only be discrepancies if some transaction has been evaluated
           

           if      ( comparison_result ) begin
                   `uvm_info("compare", $sformatf(":) the content of register: %h = %h has the expected value for chip_status: %s", slowcontrol_transaction_actual.register_address, slowcontrol_transaction_actual.register_content, chip_status_obj.chip_status), UVM_LOW)
           end
           else if ( slowcontrol_transaction_ideal.fields_with_error.exists(REGISTER_ADDRESS) ) begin // we check this transaction because it's the invoker of compare
                   `uvm_info("compare", $sformatf(":( The register_address coming from the model %h does not match that coming from the monitor %h, chip_status = %s", slowcontrol_transaction_ideal.register_address, slowcontrol_transaction_actual.register_address, chip_status_obj.chip_status), UVM_LOW)
                   increment_number_discrepancies(); 
           end
           else if ( slowcontrol_transaction_ideal.fields_with_error.exists(REGISTER_CONTENT) ) begin // we check this transaction because it's the invoker of compare
                   `uvm_info("compare", $sformatf(":( the content of register: %h = %h does NOT have the expected value = %h, chip_status: %s", slowcontrol_transaction_actual.register_address, slowcontrol_transaction_actual.register_content, slowcontrol_transaction_ideal.register_content, chip_status_obj.chip_status), UVM_LOW)
                 increment_number_discrepancies(); 
           end

           // Free the record of errors for the next comparison
           slowcontrol_transaction_ideal.fields_with_error.delete();
              
              
	endfunction: compare
  //
  task regslowcontrolcomparator_action();
       CLICTD_slowcontrol_transaction slowcontrol_transaction_ideal, slowcontrol_transaction_actual, aux_slowcontrol_transaction_ideal, aux_slowcontrol_transaction_actual;
       forever begin
					actual_fifo.get(aux_slowcontrol_transaction_actual);
					ideal_fifo.get(aux_slowcontrol_transaction_ideal);
     assert($cast( slowcontrol_transaction_ideal, aux_slowcontrol_transaction_ideal.clone() ));
     assert($cast( slowcontrol_transaction_actual, aux_slowcontrol_transaction_actual.clone() ));
					assert_isunknown_slowcontrol_transaction ( .slowcontrol_transaction(slowcontrol_transaction_ideal), .chip_status_obj(chip_status_obj), .name_of_transaction("slowcontrol_transaction_ideal"), .name_of_calling_component(this.get_full_name()) );
					assert_isunknown_slowcontrol_transaction ( .slowcontrol_transaction(slowcontrol_transaction_actual), .chip_status_obj(chip_status_obj), .name_of_transaction("slowcontrol_transaction_actual"), .name_of_calling_component(this.get_full_name()) );
					compare(slowcontrol_transaction_ideal,slowcontrol_transaction_actual);
				end
  endtask: regslowcontrolcomparator_action
  // 


endclass: CLICTD_regslowcontrol_comparator



`endif // __CLICTD_regslowcontrol_comparator_sv__

